var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports.runAndroidLog=exports.configureAndroidProperties=exports.runAndroid=exports.packageAndroid=exports.listAndroidTargets=exports.buildAndroid=exports.launchAndroidSimulator=exports.configureGradleProject=exports.copyAndroidAssets=void 0;var _regenerator=_interopRequireDefault(require("@babel/runtime/regenerator"));var _objectSpread2=_interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));var _slicedToArray2=_interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));var _path=_interopRequireDefault(require("path"));var _os=_interopRequireDefault(require("os"));var _fs=_interopRequireDefault(require("fs"));var _chalk=_interopRequireDefault(require("chalk"));var _shelljs=_interopRequireDefault(require("shelljs"));var _child_process=_interopRequireDefault(require("child_process"));var _exec=require("../systemTools/exec");var _platform=require("../cli/platform");var _common=require("../common");var _fileutils=require("../systemTools/fileutils");var _constants=require("../constants");var _pluginTools=require("../pluginTools");var readline=require('readline');var composeDevicesString=function composeDevicesString(devices,platform){var devicesArray=[];var p=platform;devices.forEach(function(v,i){if(p===_constants.ANDROID_WEAR&&v.isWear||p===_constants.ANDROID_TV&&v.isTV||p===_constants.ANDROID&&v.isMobile)devicesArray.push(_getDeviceString(v,i));});return"\n"+devicesArray.join('');};var launchAndroidSimulator=function launchAndroidSimulator(c,platform,target){var isIndependentThread=arguments.length>3&&arguments[3]!==undefined?arguments[3]:false;(0,_common.logTask)("launchAndroidSimulator:"+platform+":"+target);if(target==='?'||target===undefined||target===''){return _listAndroidTargets(c,true,false,false).then(function(devicesArr){var devicesString=composeDevicesString(devicesArr,platform);var readlineInterface=readline.createInterface({input:process.stdin,output:process.stdout});readlineInterface.question((0,_common.getQuestion)(devicesString+"\nType number of the emulator you want to launch"),function(v){var selectedDevice=devicesArr[parseInt(v,10)-1];if(selectedDevice){if(isIndependentThread){(0,_exec.execCLI)(c,_common.CLI_ANDROID_EMULATOR,"-avd \""+selectedDevice.name+"\"").catch(_common.logError);return Promise.resolve();}return(0,_exec.execCLI)(c,_common.CLI_ANDROID_EMULATOR,"-avd \""+selectedDevice.name+"\"");}(0,_common.logError)("Wrong choice "+v+"! Ingoring");});});}if(target){if(isIndependentThread){(0,_exec.execCLI)(c,_common.CLI_ANDROID_EMULATOR,"-avd \""+target+"\"").catch(_common.logError);return Promise.resolve();}return(0,_exec.execCLI)(c,_common.CLI_ANDROID_EMULATOR,"-avd \""+target+"\"");}return Promise.reject('No simulator -t target name specified!');};exports.launchAndroidSimulator=launchAndroidSimulator;var listAndroidTargets=function listAndroidTargets(c){(0,_common.logTask)('listAndroidTargets');return _listAndroidTargets(c,false,false).then(function(list){return composeDevicesString(list,c.platform);}).then(function(devices){console.log(devices);return devices;});};exports.listAndroidTargets=listAndroidTargets;var _getDeviceString=function _getDeviceString(device,i){var isTV=device.isTV,isTablet=device.isTablet,name=device.name,udid=device.udid,isDevice=device.isDevice,isActive=device.isActive,avdConfig=device.avdConfig,isWear=device.isWear;var deviceIcon='';if(isTablet)deviceIcon='Tablet 💊 ';if(isTV)deviceIcon='TV 📺 ';if(isWear)deviceIcon='Wear ⌚ ';if(!deviceIcon&&(udid!=='unknown'||avdConfig))deviceIcon='Phone 📱 ';return"-["+(i+1)+"] "+_chalk.default.white(name)+" | "+deviceIcon+" | udid: "+_chalk.default.blue(udid)+(isDevice?_chalk.default.red(' (device)'):'')+" "+(isActive?_chalk.default.magenta(' (active)'):'')+"\n";};var _listAndroidTargets=function _listAndroidTargets(c,skipDevices,skipAvds){var deviceOnly=arguments.length>3&&arguments[3]!==undefined?arguments[3]:false;var skipPlatformFilter=arguments.length>4&&arguments[4]!==undefined?arguments[4]:false;(0,_common.logTask)("_listAndroidTargets:"+c.platform);try{var devicesResult;var avdResult;if(!skipDevices){devicesResult=_child_process.default.execSync(c.cli[_common.CLI_ANDROID_ADB]+" devices -l").toString();}if(!skipAvds){avdResult=_child_process.default.execSync(c.cli[_common.CLI_ANDROID_EMULATOR]+" -list-avds").toString();}return _parseDevicesResult(devicesResult,avdResult,deviceOnly,skipPlatformFilter,c);}catch(e){return Promise.reject(e);}};var calculateDeviceDiagonal=function calculateDeviceDiagonal(width,height,density){var widthInches=width/density;var heightInches=height/density;return Math.sqrt(widthInches*widthInches+heightInches*heightInches);};var isSquareishDevice=function isSquareishDevice(width,height){var ratio=width/height;if(ratio>0.8&&ratio<1.2)return true;return false;};var getDeviceType=function getDeviceType(device,c){var dumpsysResult,screenSizeResult,screenDensityResult,screenProps,_screenSizeResult$spl,_screenSizeResult$spl2,width,height,density,_screenProps,_width,_height,_density,diagonalInches,batteryPresent,_density2,_width2,_height2,sysdir,tagId,tagDisplay,deviceName,_diagonalInches;return _regenerator.default.async(function getDeviceType$(_context){while(1){switch(_context.prev=_context.next){case 0:device.isPhone=true;device.isMobile=true;if(!(device.udid!=='unknown')){_context.next=14;break;}dumpsysResult=_child_process.default.execSync(c.cli[_common.CLI_ANDROID_ADB]+" -s "+device.udid+" shell dumpsys tv_input").toString();screenSizeResult=_child_process.default.execSync(c.cli[_common.CLI_ANDROID_ADB]+" -s "+device.udid+" shell wm size").toString();screenDensityResult=_child_process.default.execSync(c.cli[_common.CLI_ANDROID_ADB]+" -s "+device.udid+" shell wm density").toString();if(screenSizeResult){_screenSizeResult$spl=screenSizeResult.split('Physical size: ')[1].split('x'),_screenSizeResult$spl2=(0,_slicedToArray2.default)(_screenSizeResult$spl,2),width=_screenSizeResult$spl2[0],height=_screenSizeResult$spl2[1];screenProps={width:parseInt(width,10),height:parseInt(height,10)};}if(screenDensityResult){density=screenDensityResult.split('Physical density: ')[1];screenProps=(0,_objectSpread2.default)({},screenProps,{density:parseInt(density,10)});}if(screenSizeResult&&screenDensityResult){_screenProps=screenProps,_width=_screenProps.width,_height=_screenProps.height,_density=_screenProps.density;diagonalInches=calculateDeviceDiagonal(_width,_height,_density);screenProps=(0,_objectSpread2.default)({},screenProps,{diagonalInches:diagonalInches});device.isTablet=diagonalInches>_constants.IS_TABLET_ABOVE_INCH;device.isWear=isSquareishDevice(_width,_height);}device.isTV=!!dumpsysResult;device.isPhone=!device.isTablet&&!device.isWear&&!device.isTV;device.isMobile=!device.isWear&&!device.isTV;device.screenProps=screenProps;return _context.abrupt("return",device);case 14:if(!device.avdConfig){_context.next=31;break;}batteryPresent=device.avdConfig['hw.battery'];_density2=parseInt(device.avdConfig['hw.lcd.density'],10);_width2=parseInt(device.avdConfig['hw.lcd.width'],10);_height2=parseInt(device.avdConfig['hw.lcd.height'],10);sysdir=device.avdConfig['image.sysdir.1'];tagId=device.avdConfig['tag.id'];tagDisplay=device.avdConfig['tag.display'];deviceName=device.avdConfig['hw.device.name'];device.isWear=false;[sysdir,tagId,tagDisplay,deviceName].forEach(function(string){if(string.includes('wear'))device.isWear=true;});_diagonalInches=calculateDeviceDiagonal(_width2,_height2,_density2);device.isTablet=_diagonalInches>_constants.IS_TABLET_ABOVE_INCH;device.isTV=batteryPresent!=='yes';device.isPhone=!device.isTablet&&!device.isWear&&!device.isTV;device.isMobile=!device.isWear&&!device.isTV;return _context.abrupt("return",device);case 31:return _context.abrupt("return",device);case 32:case"end":return _context.stop();}}});};var getAvdDetails=function getAvdDetails(deviceName){var avdConfigPath,fileData,lines,avdConfig;return _regenerator.default.async(function getAvdDetails$(_context2){while(1){switch(_context2.prev=_context2.next){case 0:avdConfigPath=_os.default.homedir()+"/.android/avd/"+deviceName+".avd/config.ini";if(!_fs.default.existsSync(avdConfigPath)){_context2.next=7;break;}fileData=_fs.default.readFileSync(avdConfigPath).toString();lines=fileData.trim().split(/\r?\n/);avdConfig={};lines.forEach(function(line){var _line$split=line.split('='),_line$split2=(0,_slicedToArray2.default)(_line$split,2),key=_line$split2[0],value=_line$split2[1];avdConfig[key.trim()]=value.trim();});return _context2.abrupt("return",{avdConfig:avdConfig});case 7:return _context2.abrupt("return",{});case 8:case"end":return _context2.stop();}}});};var _parseDevicesResult=function _parseDevicesResult(devicesString,avdsString,deviceOnly,skipPlatformFilter,c){var devices,_lines,i,words,isDevice,avdLines;return _regenerator.default.async(function _parseDevicesResult$(_context4){while(1){switch(_context4.prev=_context4.next){case 0:devices=[];if(devicesString){_lines=devicesString.trim().split(/\r?\n/);for(i=0;i<_lines.length;i++){words=_lines[i].split(/[ ,\t]+/).filter(function(w){return w!=='';});if(words[1]==='device'){isDevice=!words[0].includes('emulator');if(deviceOnly&&isDevice||!deviceOnly){devices.push({udid:words[0],isDevice:isDevice,isActive:true,name:_getDeviceProp(words,'model:')});}}}}if(!avdsString){_context4.next=6;break;}avdLines=avdsString.trim().split(/\r?\n/);_context4.next=6;return _regenerator.default.awrap(Promise.all(avdLines.map(function _callee(line){var avdDetails;return _regenerator.default.async(function _callee$(_context3){while(1){switch(_context3.prev=_context3.next){case 0:_context3.next=2;return _regenerator.default.awrap(getAvdDetails(line));case 2:avdDetails=_context3.sent;try{_child_process.default.execSync("ps x | grep \"qemu.*"+line+"\" | grep -v grep");}catch(e){devices.push((0,_objectSpread2.default)({udid:'unknown',isDevice:false,isActive:false,name:line},avdDetails));}case 4:case"end":return _context3.stop();}}});})));case 6:return _context4.abrupt("return",Promise.all(devices.map(function(device){return getDeviceType(device,c);})));case 7:case"end":return _context4.stop();}}});};var _getDeviceProp=function _getDeviceProp(arr,prop){for(var _i=0;_i<arr.length;_i++){var v=arr[_i];if(v&&v.includes(prop))return v.replace(prop,'');}return'';};var _askForNewEmulator=function _askForNewEmulator(c,platform){return new Promise(function(resolve,reject){(0,_common.logTask)('_askForNewEmulator');var emuName=c.files.globalConfig.defaultTargets[platform];var readlineInterface=readline.createInterface({input:process.stdin,output:process.stdout});readlineInterface.question((0,_common.getQuestion)("Do you want ReNative to create new Emulator ("+_chalk.default.white(emuName)+") for you? (y) to confirm"),function(v){if(v.toLowerCase()==='y'){readlineInterface.question((0,_common.getQuestion)('Input desired Android API version number'),function(v){var apiVersion=v;readlineInterface.question((0,_common.getQuestion)('Select device type: \n 1: Android Phone \n 2: Android TV \n 3: Android Wear \n'),function(val){switch(parseInt(val,10)){case 1:return _createEmulator(c,apiVersion,'google_apis',emuName);case 2:return _createEmulator(c,apiVersion,'android-tv',emuName);case 3:return _createEmulator(c,apiVersion,'android-wear',emuName);default:return reject('Wrong value entered');}});});}else{reject('Cannot find any active emulators');}});});};var _createEmulator=function _createEmulator(c,apiVersion,emuPlatform,emuName){(0,_common.logTask)('_createEmulator');return(0,_exec.execCLI)(c,_common.CLI_ANDROID_SDKMANAGER,"\"system-images;android-"+apiVersion+";"+emuPlatform+";x86\"").then(function(){return(0,_exec.execCLI)(c,_common.CLI_ANDROID_AVDMANAGER,"create avd  -n "+emuName+" -k \"system-images;android-"+apiVersion+";"+emuPlatform+";x86\" ");}).catch(function(e){return(0,_common.logError)(e,true);});};var copyAndroidAssets=function copyAndroidAssets(c,platform){return new Promise(function(resolve){(0,_common.logTask)('copyAndroidAssets');if(!(0,_common.isPlatformActive)(c,platform,resolve))return;var destPath=_path.default.join((0,_common.getAppFolder)(c,platform),'app/src/main/res');var sourcePath=_path.default.join(c.paths.appConfigFolder,"assets/"+platform+"/res");(0,_fileutils.copyFolderContentsRecursiveSync)(sourcePath,destPath);resolve();});};exports.copyAndroidAssets=copyAndroidAssets;var packageAndroid=function packageAndroid(c,platform){return new Promise(function(resolve,reject){(0,_common.logTask)('packageAndroid');var entryFile=c.files.appConfigFile.platforms[platform].entryFile;var outputFile=entryFile;var appFolder=(0,_common.getAppFolder)(c,platform);(0,_exec.executeAsync)('react-native',['bundle','--platform','android','--dev','false','--assets-dest',appFolder+"/app/src/main/res",'--entry-file',entryFile+".js",'--bundle-output',appFolder+"/app/src/main/assets/"+outputFile+".bundle"]).then(function(){return resolve();}).catch(function(e){return reject(e);});});};exports.packageAndroid=packageAndroid;var runAndroid=function runAndroid(c,platform,target){return new Promise(function(resolve,reject){(0,_common.logTask)("runAndroid:"+platform+":"+target);var bundleAssets=(0,_common.getConfigProp)(c,platform,'bundleAssets',false)===true;var bundleIsDev=(0,_common.getConfigProp)(c,platform,'bundleIsDev',false)===true;if(bundleAssets){packageAndroid(c,platform,bundleIsDev).then(function(){return _runGradle(c,platform);}).then(function(){return resolve();}).catch(function(e){return reject(e);});}else{_runGradle(c,platform).then(function(){return resolve();}).catch(function(e){return reject(e);});}});};exports.runAndroid=runAndroid;var _runGradle=function _runGradle(c,platform){var appFolder,signingConfig,devicesArr,dv,devicesString,readlineInterface,device;return _regenerator.default.async(function _runGradle$(_context5){while(1){switch(_context5.prev=_context5.next){case 0:(0,_common.logTask)("_runGradle:"+platform);appFolder=(0,_common.getAppFolder)(c,platform);_shelljs.default.cd(""+appFolder);signingConfig=(0,_common.getConfigProp)(c,platform,'signingConfig','Debug');_context5.next=6;return _regenerator.default.awrap(_listAndroidTargets(c,false,true,c.program.device!==undefined));case 6:devicesArr=_context5.sent;if(!(devicesArr.length===1)){_context5.next=14;break;}dv=devicesArr[0];(0,_common.logInfo)("Found device "+dv.name+":"+dv.udid+"!");_context5.next=12;return _regenerator.default.awrap(_runGradleApp(c,platform,appFolder,signingConfig,dv));case 12:_context5.next=34;break;case 14:if(!(devicesArr.length>1)){_context5.next=22;break;}(0,_common.logWarning)('More than one device is connected!');devicesString=composeDevicesString(devicesArr,platform);readlineInterface=readline.createInterface({input:process.stdin,output:process.stdout});_context5.next=20;return _regenerator.default.awrap(new Promise(function(resolve,reject){return readlineInterface.question((0,_common.getQuestion)(devicesString+"\nType number of the device to use"),function(v){var selectedDevice=devicesArr[parseInt(v,10)-1];if(selectedDevice){(0,_common.logInfo)("Selected device "+selectedDevice.name+":"+selectedDevice.udid+"!");_runGradleApp(c,platform,appFolder,signingConfig,selectedDevice).then(resolve).catch(reject);}else{(0,_common.logError)("Wrong choice "+v+"! Ingoring");}});}));case 20:_context5.next=34;break;case 22:if(!c.files.globalConfig.defaultTargets[platform]){_context5.next=33;break;}(0,_common.logWarning)("No connected devices found. Launching "+_chalk.default.white(c.files.globalConfig.defaultTargets[platform])+" emulator!");_context5.next=26;return _regenerator.default.awrap(launchAndroidSimulator(c,platform,c.files.globalConfig.defaultTargets[platform],true));case 26:_context5.next=28;return _regenerator.default.awrap(_checkForActiveEmulator(c,platform));case 28:device=_context5.sent;_context5.next=31;return _regenerator.default.awrap(_runGradleApp(c,platform,appFolder,signingConfig,device));case 31:_context5.next=34;break;case 33:throw new Error("No active or connected devices! You can launch android emulator with "+_chalk.default.white('rnv target launch -p android -t <TARGET_NAME>'));case 34:case"end":return _context5.stop();}}});};var _checkForActiveEmulator=function _checkForActiveEmulator(c,platform){return new Promise(function(resolve){var attempts=1;var maxAttempts=8;var poll=setInterval(function(){_listAndroidTargets(c,false,true,false).then(function(v){if(v.length>0){(0,_common.logSuccess)("Found active emulator! "+_chalk.default.white(v[0].udid)+". Will use it");clearInterval(poll);resolve(v[0]);}else{console.log("looking for active emulators: attempt "+attempts+"/"+maxAttempts);attempts++;if(attempts>maxAttempts){clearInterval(poll);return _askForNewEmulator(c,platform);}}}).catch(function(e){clearInterval(poll);(0,_common.logError)(e);});},2000);});};var _checkSigningCerts=function _checkSigningCerts(c){return new Promise(function(resolve,reject){var signingConfig=(0,_common.getConfigProp)(c,c.platform,'signingConfig','Debug');if(signingConfig==='Release'&&!c.files.privateConfig){(0,_common.logError)("You're attempting to "+c.command+" app in release mode but you have't configured your "+_chalk.default.white(c.paths.privateConfigPath)+" yet.");(0,_common.askQuestion)('Do you want to configure it now? (y)').then(function(v){var sc={};if(v==='y'){(0,_common.askQuestion)("Paste asolute or relative path to "+_chalk.default.white(c.paths.privateConfigDir)+" of your existing "+_chalk.default.white('release.keystore')+" file.",sc,'storeFile').then(function(){return(0,_common.askQuestion)('storePassword',sc,'storePassword');}).then(function(){return(0,_common.askQuestion)('keyAlias',sc,'keyAlias');}).then(function(){return(0,_common.askQuestion)('keyPassword',sc,'keyPassword');}).then(function(){(0,_common.finishQuestion)();if(c.paths.privateConfigDir){(0,_fileutils.mkdirSync)(c.paths.privateConfigDir);c.files.privateConfig={android:sc};}_fs.default.writeFileSync(c.paths.privateConfigPath,JSON.stringify(c.files.privateConfig,null,2));(0,_common.logSuccess)("Successfully created private config file at "+_chalk.default.white(c.paths.privateConfigPath)+".");resolve();});}else{reject("You selected "+v+". Can't proceed");}}).catch(function(e){return reject(e);});}else{resolve();}});};var _runGradleApp=function _runGradleApp(c,platform,appFolder,signingConfig,device){return new Promise(function(resolve,reject){var bundleId=(0,_common.getConfigProp)(c,platform,'id');var outputFolder=signingConfig==='Debug'?'debug':'release';_checkSigningCerts(c).then(function(){return(0,_exec.executeAsync)(process.platform==='win32'?'gradlew.bat':'./gradlew',["assemble"+signingConfig,'-x','bundleReleaseJsAndAssets']);}).then(function(){var apkPath=_path.default.join(appFolder,"app/build/outputs/apk/"+outputFolder+"/app-"+outputFolder+".apk");if(!_fs.default.existsSync(apkPath)){apkPath=_path.default.join(appFolder,"app/build/outputs/apk/"+outputFolder+"/app-"+outputFolder+"-unsigned.apk");}return(0,_exec.executeAsync)(c.cli[_common.CLI_ANDROID_ADB],['-s',device.udid,'install','-r','-d','-f',apkPath]);}).then(function(){return device.isDevice&&platform!==_constants.ANDROID_WEAR?(0,_exec.executeAsync)(c.cli[_common.CLI_ANDROID_ADB],['-s',device.udid,'reverse','tcp:8081','tcp:8081']):Promise.resolve();}).then(function(){return(0,_exec.executeAsync)(c.cli[_common.CLI_ANDROID_ADB],['-s',device.udid,'shell','am','start','-n',bundleId+"/.MainActivity"]);}).then(function(){return resolve();}).catch(function(e){return reject(e);});});};var buildAndroid=function buildAndroid(c,platform){return new Promise(function(resolve,reject){(0,_common.logTask)("buildAndroid:"+platform);_checkSigningCerts(c).then(function(){var appFolder=(0,_common.getAppFolder)(c,platform);_shelljs.default.cd(""+appFolder);_shelljs.default.exec('./gradlew assembleRelease -x bundleReleaseJsAndAssets',function(error){if(error){(0,_common.logError)("Command 'gradlew assembleRelease -x bundleReleaseJsAndAssets' failed with error code "+error,true);return;}(0,_common.logSuccess)("Your APK is located in "+_chalk.default.white(_path.default.join(appFolder,'app/build/outputs/apk/release'))+".");resolve();});}).catch(function(e){return reject(e);});});};exports.buildAndroid=buildAndroid;var configureAndroidProperties=function configureAndroidProperties(c){return new Promise(function(resolve){(0,_common.logTask)('configureAndroidProperties');var localProperties=_path.default.join(c.paths.globalConfigFolder,'local.properties');if(_fs.default.existsSync(localProperties)){console.log('local.properties file exists!');}else{console.log('local.properties file missing! Creating one for you...');}_fs.default.writeFileSync(localProperties,"#Generated by ReNative (https://renative.org)\nndk.dir="+c.files.globalConfig.sdks.ANDROID_NDK+"\nsdk.dir="+c.files.globalConfig.sdks.ANDROID_SDK);resolve();});};exports.configureAndroidProperties=configureAndroidProperties;var configureGradleProject=function configureGradleProject(c,platform){return new Promise(function(resolve,reject){(0,_common.logTask)("configureGradleProject:"+platform);if(!(0,_common.isPlatformActive)(c,platform,resolve))return;configureAndroidProperties(c,platform).then(function(){return copyAndroidAssets(c,platform);}).then(function(){return(0,_common.copyBuildsFolder)(c,platform);}).then(function(){return configureProject(c,platform);}).then(function(){return resolve();}).catch(function(e){return reject(e);});});};exports.configureGradleProject=configureGradleProject;var _injectPlugin=function _injectPlugin(c,plugin,key,pkg,pluginConfig){var className=pkg?pkg.split('.').pop():null;var packageParams='';if(plugin.packageParams){packageParams=plugin.packageParams.join(',');}var pathFixed=plugin.path?""+plugin.path:"node_modules/"+key+"/android";var modulePath="../../"+pathFixed;if(plugin.projectName){pluginConfig.pluginIncludes+=", ':"+plugin.projectName+"'";pluginConfig.pluginPaths+="project(':"+plugin.projectName+"').projectDir = new File(rootProject.projectDir, '"+modulePath+"')\n";if(!plugin.skipImplementation){if(plugin.implementation){pluginConfig.pluginImplementations+=""+plugin.implementation;}else{pluginConfig.pluginImplementations+="    implementation project(':"+plugin.projectName+"')\n";}}}else{pluginConfig.pluginIncludes+=", ':"+key+"'";pluginConfig.pluginPaths+="project(':"+key+"').projectDir = new File(rootProject.projectDir, '"+modulePath+"')\n";if(!plugin.skipImplementation){if(plugin.implementation){pluginConfig.pluginImplementations+=""+plugin.implementation;}else{pluginConfig.pluginImplementations+="    implementation project(':"+key+"')\n";}}}if(plugin.activityImports instanceof Array){plugin.activityImports.forEach(function(activityImport){if(pluginConfig.pluginActivityImports.indexOf(activityImport)===-1){pluginConfig.pluginActivityImports+="import "+activityImport+"\n";}});}if(plugin.activityMethods instanceof Array){pluginConfig.pluginActivityMethods+=""+plugin.activityMethods.join('\n    ');}if(pkg)pluginConfig.pluginImports+="import "+pkg+"\n";if(className)pluginConfig.pluginPackages+=className+"("+packageParams+"),\n";if(plugin.implementations){plugin.implementations.forEach(function(v){pluginConfig.pluginImplementations+="    implementation '"+v+"'\n";});}if(plugin.afterEvaluate){plugin.afterEvaluate.forEach(function(v){pluginConfig.pluginAfterEvaluate+=" "+v+"\n";});}_fixAndroidLegacy(c,pathFixed);};var _fixAndroidLegacy=function _fixAndroidLegacy(c,modulePath){var buildGradle=_path.default.join(c.paths.projectRootFolder,modulePath,'build.gradle');if(_fs.default.existsSync(buildGradle)){(0,_common.logDebug)('FIX:',buildGradle);(0,_common.writeCleanFile)(buildGradle,buildGradle,[{pattern:" compile '",override:"  implementation '"},{pattern:' compile "',override:'  implementation "'},{pattern:' testCompile "',override:'  testImplementation "'},{pattern:" provided '",override:"  compileOnly '"},{pattern:' provided "',override:'  compileOnly "'},{pattern:' compile fileTree',override:'  implementation fileTree'}]);}};var configureProject=function configureProject(c,platform){return new Promise(function(resolve,reject){(0,_common.logTask)("configureProject:"+platform);var appFolder=(0,_common.getAppFolder)(c,platform);var appTemplateFolder=(0,_common.getAppTemplateFolder)(c,platform);var gradlew=_path.default.join(appFolder,'gradlew');if(!_fs.default.existsSync(gradlew)){(0,_common.logWarning)("Looks like your "+_chalk.default.white(platform)+" platformBuild is misconfigured!. let's repair it.");(0,_platform.createPlatformBuild)(c,platform).then(function(){return configureGradleProject(c,platform);}).then(function(){return resolve(c);}).catch(function(e){return reject(e);});return;}(0,_fileutils.copyFileSync)(_path.default.join(c.paths.globalConfigFolder,'local.properties'),_path.default.join(appFolder,'local.properties'));(0,_fileutils.mkdirSync)(_path.default.join(appFolder,'app/src/main/assets'));_fs.default.writeFileSync(_path.default.join(appFolder,'app/src/main/assets/index.android.bundle'),'{}');_fs.default.chmodSync(gradlew,'755');var pluginIncludes="include ':app'";var pluginPaths='';var pluginImports='';var pluginPackages='MainReactPackage(),\n';var pluginImplementations='';var pluginAfterEvaluate='';var pluginActivityImports='';var pluginActivityMethods='';var pluginConfig={pluginIncludes:pluginIncludes,pluginPaths:pluginPaths,pluginImports:pluginImports,pluginPackages:pluginPackages,pluginImplementations:pluginImplementations,pluginAfterEvaluate:pluginAfterEvaluate,pluginActivityImports:pluginActivityImports,pluginActivityMethods:pluginActivityMethods};if(c.files.appConfigFile&&c.files.pluginConfig){var includedPlugins=c.files.appConfigFile.common.includedPlugins;if(includedPlugins){var plugins=c.files.pluginConfig.plugins;Object.keys(plugins).forEach(function(key){if(includedPlugins.includes('*')||includedPlugins.includes(key)){var plugin=(0,_pluginTools.getOriginalPlugin)(c,key,plugins)[platform];if(plugin){if(plugins[key]['no-active']!==true){if(plugin.packages){plugin.packages.forEach(function(ppkg){_injectPlugin(c,plugin,key,ppkg,pluginConfig);});}else{_injectPlugin(c,plugin,key,plugin.package,pluginConfig);}}}}});}}pluginConfig.pluginPackages=pluginConfig.pluginPackages.substring(0,pluginConfig.pluginPackages.length-2);if(c.files.appConfigFile){if(_fs.default.existsSync(c.paths.fontsConfigFolder)){_fs.default.readdirSync(c.paths.fontsConfigFolder).forEach(function(font){if(font.includes('.ttf')||font.includes('.otf')){var key=font.split('.')[0];var includedFonts=c.files.appConfigFile.common.includedFonts;if(includedFonts){if(includedFonts.includes('*')||includedFonts.includes(key)){if(font){var fontSource=_path.default.join(c.paths.projectConfigFolder,'fonts',font);if(_fs.default.existsSync(fontSource)){var fontFolder=_path.default.join(appFolder,'app/src/main/assets/fonts');(0,_fileutils.mkdirSync)(fontFolder);var fontDest=_path.default.join(fontFolder,font);(0,_fileutils.copyFileSync)(fontSource,fontDest);}else{(0,_common.logWarning)("Font "+_chalk.default.white(fontSource)+" doesn't exist! Skipping.");}}}}}});}}pluginConfig.signingConfigs='release';pluginConfig.localProperties='';c.files.privateConfig=_getPrivateConfig(c,platform);if(c.files.privateConfig){var keystorePath=c.files.privateConfig[platform].storeFile;var keystorePathFull;if(keystorePath){if(keystorePath.startsWith('./')){keystorePathFull=_path.default.join(c.files.privateConfig.parentFolder,keystorePath);}else{keystorePathFull=keystorePath;}}if(_fs.default.existsSync(keystorePathFull)){var genPropsPath=_path.default.join(appFolder,'keystore.properties');_fs.default.writeFileSync(genPropsPath,"# auto generated by ReNative\nstoreFile="+keystorePathFull+"\nkeyAlias="+c.files.privateConfig[platform].keyAlias+"\nstorePassword="+c.files.privateConfig[platform].storePassword+"\nkeyPassword="+c.files.privateConfig[platform].keyPassword);pluginConfig.signingConfigs="\n            release {\n                storeFile file(keystoreProps['storeFile'])\n                storePassword keystoreProps['storePassword']\n                keyAlias keystoreProps['keyAlias']\n                keyPassword keystoreProps['keyPassword']\n            }";pluginConfig.localProperties="\n          def keystorePropsFile = rootProject.file(\"keystore.properties\")\n          def keystoreProps = new Properties()\n          keystoreProps.load(new FileInputStream(keystorePropsFile))";}else{(0,_common.logWarning)("Your "+_chalk.default.white(keystorePathFull)+" does not exist. You won't be able to make production releases without it!");}}(0,_common.writeCleanFile)(_path.default.join(appTemplateFolder,'settings.gradle'),_path.default.join(appFolder,'settings.gradle'),[{pattern:'{{PLUGIN_INCLUDES}}',override:pluginConfig.pluginIncludes},{pattern:'{{PLUGIN_PATHS}}',override:pluginConfig.pluginPaths}]);(0,_common.writeCleanFile)(_path.default.join(appTemplateFolder,'app/build.gradle'),_path.default.join(appFolder,'app/build.gradle'),[{pattern:'{{APPLICATION_ID}}',override:(0,_common.getAppId)(c,platform)},{pattern:'{{VERSION_CODE}}',override:(0,_common.getAppVersionCode)(c,platform)},{pattern:'{{VERSION_NAME}}',override:(0,_common.getAppVersion)(c,platform)},{pattern:'{{PLUGIN_IMPLEMENTATIONS}}',override:pluginConfig.pluginImplementations},{pattern:'{{PLUGIN_AFTER_EVALUATE}}',override:pluginConfig.pluginAfterEvaluate},{pattern:'{{PLUGIN_SIGNING_CONFIGS}}',override:pluginConfig.signingConfigs},{pattern:'{{PLUGIN_LOCAL_PROPERTIES}}',override:pluginConfig.localProperties}]);var activityPath='app/src/main/java/rnv/MainActivity.kt';(0,_common.writeCleanFile)(_path.default.join(appTemplateFolder,activityPath),_path.default.join(appFolder,activityPath),[{pattern:'{{APPLICATION_ID}}',override:(0,_common.getAppId)(c,platform)},{pattern:'{{PLUGIN_ACTIVITY_IMPORTS}}',override:pluginConfig.pluginActivityImports},{pattern:'{{PLUGIN_ACTIVITY_METHODS}}',override:pluginConfig.pluginActivityMethods}]);var applicationPath='app/src/main/java/rnv/MainApplication.kt';(0,_common.writeCleanFile)(_path.default.join(appTemplateFolder,applicationPath),_path.default.join(appFolder,applicationPath),[{pattern:'{{APPLICATION_ID}}',override:(0,_common.getAppId)(c,platform)},{pattern:'{{ENTRY_FILE}}',override:(0,_common.getEntryFile)(c,platform)},{pattern:'{{PLUGIN_IMPORTS}}',override:pluginConfig.pluginImports},{pattern:'{{PLUGIN_PACKAGES}}',override:pluginConfig.pluginPackages}]);var splashPath='app/src/main/java/rnv/SplashActivity.kt';(0,_common.writeCleanFile)(_path.default.join(appTemplateFolder,splashPath),_path.default.join(appFolder,splashPath),[{pattern:'{{APPLICATION_ID}}',override:(0,_common.getAppId)(c,platform)}]);var stringsPath='app/src/main/res/values/strings.xml';(0,_common.writeCleanFile)(_path.default.join(appTemplateFolder,stringsPath),_path.default.join(appFolder,stringsPath),[{pattern:'{{APP_TITLE}}',override:(0,_common.getAppTitle)(c,platform)}]);var prms='';var permissions=c.files.appConfigFile.platforms[platform].permissions;if(permissions){permissions.forEach(function(v){if(c.files.permissionsConfig){var plat=c.files.permissionsConfig.permissions[platform]?platform:'android';var pc=c.files.permissionsConfig.permissions[plat];if(pc[v]){prms+="\n<uses-permission android:name=\""+pc[v].key+"\" />";}}});}var manifestFile='app/src/main/AndroidManifest.xml';(0,_common.writeCleanFile)(_path.default.join(appTemplateFolder,manifestFile),_path.default.join(appFolder,manifestFile),[{pattern:'{{APPLICATION_ID}}',override:(0,_common.getAppId)(c,platform)},{pattern:'{{PERMISIONS}}',override:prms}]);resolve();});};var _getPrivateConfig=function _getPrivateConfig(c,platform){var privateConfigFolder=_path.default.join(c.paths.globalConfigFolder,c.files.projectPackage.name,c.files.appConfigFile.id);var appConfigSPP=c.files.appConfigFile.platforms[platform]?c.files.appConfigFile.platforms[platform].signingPropertiesPath:null;var appConfigSPPClean=appConfigSPP?appConfigSPP.replace('{globalConfigFolder}',c.paths.globalConfigFolder):null;var privateConfigPath=appConfigSPPClean||_path.default.join(privateConfigFolder,'config.private.json');c.paths.privateConfigPath=privateConfigPath;c.paths.privateConfigDir=privateConfigPath.replace('/config.private.json','');if(_fs.default.existsSync(privateConfigPath)){try{var output=JSON.parse(_fs.default.readFileSync(privateConfigPath));output.parentFolder=c.paths.privateConfigDir;output.path=privateConfigPath;(0,_common.logInfo)("Found "+_chalk.default.white(privateConfigPath)+". Will use it for production releases!");return output;}catch(e){(0,_common.logError)(e);return null;}}else{(0,_common.logWarning)("You're missing "+_chalk.default.white(privateConfigPath)+" for this app: . You won't be able to make production releases without it!");return null;}};var runAndroidLog=function runAndroidLog(c){return new Promise(function(){var filter=c.program.filter||'';var child=_child_process.default.spawn(c.cli[_common.CLI_ANDROID_ADB],['logcat']);child.stdout.on('data',function(data){var d=data.toString().split('\n');d.forEach(function(v){if(v.includes(' E ')&&v.includes(filter)){console.log(_chalk.default.red(v));}else if(v.includes(' W ')&&v.includes(filter)){console.log(_chalk.default.yellow(v));}else if(v.includes(filter)){console.log(v);}});});});};exports.runAndroidLog=runAndroidLog;