var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports.buildWebOSProject=exports.runWebOS=exports.configureWebOSProject=exports.copyWebOSAssets=exports.launchWebOSimulator=void 0;var _path=_interopRequireDefault(require("path"));var _fs=_interopRequireDefault(require("fs"));var _shelljs=_interopRequireDefault(require("shelljs"));var _chalk=_interopRequireDefault(require("chalk"));var _exec=require("../systemTools/exec");var _common=require("../common");var _fileutils=require("../systemTools/fileutils");var _web=require("./web");var launchWebOSimulator=function launchWebOSimulator(c,name){return new Promise(function(resolve,reject){(0,_common.logTask)('launchWebOSimulator');var ePath=_path.default.join(c.files.globalConfig.sdks.WEBOS_SDK,'Emulator/v4.0.0/LG_webOS_TV_Emulator_RCU.app');if(!_fs.default.existsSync(ePath)){reject("Can't find emulator at path: "+ePath);return;}var childProcess=require('child_process');childProcess.exec("open "+ePath,function(err,stdout,stderr){if(err){reject(err);return;}resolve();});});};exports.launchWebOSimulator=launchWebOSimulator;var copyWebOSAssets=function copyWebOSAssets(c,platform){return new Promise(function(resolve,reject){(0,_common.logTask)('copyWebOSAssets');if(!(0,_common.isPlatformActive)(c,platform,resolve))return;var sourcePath=_path.default.join(c.paths.appConfigFolder,'assets',platform);var destPath=_path.default.join((0,_common.getAppFolder)(c,platform),'RNVApp');(0,_fileutils.copyFolderContentsRecursiveSync)(sourcePath,destPath);resolve();});};exports.copyWebOSAssets=copyWebOSAssets;var runWebOS=function runWebOS(c,platform,target){return new Promise(function(resolve,reject){(0,_common.logTask)("runWebOS:"+platform+":"+target);var tDir=_path.default.join((0,_common.getAppFolder)(c,platform),'RNVApp');var tOut=_path.default.join((0,_common.getAppFolder)(c,platform),'output');var tSim=c.program.target||'emulator';var configFilePath=_path.default.join((0,_common.getAppFolder)(c,platform),'RNVApp/appinfo.json');var cnfg=JSON.parse(_fs.default.readFileSync(configFilePath,'utf-8'));var tId=cnfg.id;var appPath=_path.default.join(tOut,tId+"_"+cnfg.version+"_all.ipk");configureWebOSProject(c,platform).then(function(){return(0,_web.buildWeb)(c,platform);}).then(function(){return(0,_exec.execCLI)(c,_common.CLI_WEBOS_ARES_PACKAGE,"-o "+tOut+" "+tDir+" -n",_common.logTask);}).then(function(){return(0,_exec.execCLI)(c,_common.CLI_WEBBOS_ARES_INSTALL,"--device "+tSim+" "+appPath,_common.logTask);}).then(function(){return(0,_exec.execCLI)(c,_common.CLI_WEBBOS_ARES_LAUNCH,"--device "+tSim+" "+tId,_common.logTask);}).then(function(){return resolve();}).catch(function(e){if(e&&e.toString().includes(_common.CLI_WEBBOS_ARES_INSTALL)){(0,_common.logWarning)("Looks like there is no emulator or device connected! Let's try to launch it. \""+_chalk.default.white.bold("rnv target launch -p webos -t "+target)+"\"");launchWebOSimulator(c,target).then(function(){(0,_common.logInfo)("Once simulator is ready run: \""+_chalk.default.white.bold("rnv run -p "+platform+" -t "+target)+"\" again");resolve();}).catch(function(e){return reject(e);});}else{reject(e);}});});};exports.runWebOS=runWebOS;var buildWebOSProject=function buildWebOSProject(c,platform){return new Promise(function(resolve,reject){(0,_common.logTask)("buildWebOSProject:"+platform);var tDir=_path.default.join((0,_common.getAppFolder)(c,platform),'public');var tOut=_path.default.join((0,_common.getAppFolder)(c,platform),'output');var configFilePath=_path.default.join((0,_common.getAppFolder)(c,platform),'RNVApp/appinfo.json');var cnfg=JSON.parse(_fs.default.readFileSync(configFilePath,'utf-8'));var tId=cnfg.id;var appPath=_path.default.join(tOut,tId+"_"+cnfg.version+"_all.ipk");configureWebOSProject(c,platform).then(function(){return(0,_web.buildWeb)(c,platform);}).then(function(){return(0,_exec.execCLI)(c,_common.CLI_WEBOS_ARES_PACKAGE,"-o "+tOut+" "+tDir+" -n",_common.logTask);}).then(function(){(0,_common.logSuccess)("Your IPK package is located in "+_chalk.default.white(tOut)+".");return resolve();}).catch(function(e){return reject();});});};exports.buildWebOSProject=buildWebOSProject;var configureWebOSProject=function configureWebOSProject(c,platform){return new Promise(function(resolve,reject){(0,_common.logTask)('configureWebOSProject');if(!(0,_common.isPlatformActive)(c,platform,resolve))return;copyWebOSAssets(c,platform).then(function(){return(0,_common.copyBuildsFolder)(c,platform);}).then(function(){return configureProject(c,platform);}).then(function(){return resolve();}).catch(function(e){return reject(e);});});};exports.configureWebOSProject=configureWebOSProject;var configureProject=function configureProject(c,platform){return new Promise(function(resolve,reject){(0,_common.logTask)("configureProject:"+platform);var appFolder=(0,_common.getAppFolder)(c,platform);var configFile='RNVApp/appinfo.json';(0,_common.writeCleanFile)(_path.default.join((0,_common.getAppTemplateFolder)(c,platform),configFile),_path.default.join(appFolder,configFile),[{pattern:'{{APPLICATION_ID}}',override:(0,_common.getAppId)(c,platform)},{pattern:'{{APP_TITLE}}',override:(0,_common.getAppTitle)(c,platform)},{pattern:'{{APP_VERSION}}',override:(0,_common.getAppVersion)(c,platform)}]);resolve();});};