var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports.checkIfTemplateInstalled=exports.applyTemplate=exports.getTemplateOptions=exports.addTemplate=exports.listTemplates=void 0;var _chalk=_interopRequireDefault(require("chalk"));var _fs=_interopRequireDefault(require("fs"));var _path=_interopRequireDefault(require("path"));var _exec=require("../systemTools/exec");var _fileutils=require("../systemTools/fileutils");var _common=require("../common");var _pluginTools=require("../pluginTools");var DEFAULT_TEMPLATES=['renative-template-hello-world','renative-template-blank'];var listTemplates=function listTemplates(){return new Promise(function(resolve,reject){opts=(0,_common.generateOptions)(DEFAULT_TEMPLATES);console.log(opts.asString);resolve();});};exports.listTemplates=listTemplates;var addTemplate=function addTemplate(){return new Promise(function(resolve,reject){(0,_exec.executeAsync)('npm',['install','renative-template-hello-world','--save-dev']).then(function(){resolve();}).catch(function(error){return(0,_common.logError)(error);});});};exports.addTemplate=addTemplate;var checkIfTemplateInstalled=function checkIfTemplateInstalled(c){return new Promise(function(resolve,reject){var templateName=c.files.projectConfig.defaultProjectConfigs?c.files.projectConfig.defaultProjectConfigs.template:null;if(!templateName){templateName='renative-template-hello-world';(0,_common.logWarning)("You're missing template name in your "+_chalk.default.white(c.paths.projectConfigPath)+". ReNative will add default "+_chalk.default.white(templateName)+" for you");if(c.files.projectConfig.defaultProjectConfigs)c.files.projectConfig.defaultProjectConfigs={};c.files.projectConfig.defaultProjectConfigs.template=templateName;_fs.default.writeFileSync(c.paths.projectConfigPath,JSON.stringify(c.files.projectConfig,null,2));}c.paths.templateFolder=_path.default.join(c.paths.projectNodeModulesFolder,templateName);if(!_fs.default.existsSync(c.paths.templateFolder)){(0,_common.logWarning)("Your "+_chalk.default.white(c.paths.templateFolder)+" template is not installed. ReNative will install it for you");c._requiresNpmInstall=true;}resolve();});};exports.checkIfTemplateInstalled=checkIfTemplateInstalled;var applyTemplate=function applyTemplate(c){return new Promise(function(resolve,reject){(0,_common.logTask)("applyTemplate:"+c.files.projectConfig.defaultProjectConfigs.template);var templateFolder=_path.default.join(c.paths.projectNodeModulesFolder,c.files.projectConfig.defaultProjectConfigs.template);var templateAppConfigsFolder=_path.default.join(templateFolder,'appConfigs');var templateAppConfigFolder=_fs.default.readdirSync(templateAppConfigsFolder)[0];var templateProjectConfigFolder=_path.default.join(templateFolder,'projectConfig');if(templateAppConfigFolder)c.defaultAppConfigId=templateAppConfigFolder;(0,_common.logTask)('configureProject:check src');if(!_fs.default.existsSync(c.paths.projectSourceFolder)){(0,_common.logWarning)("Looks like your src folder "+_chalk.default.white(c.paths.projectSourceFolder)+" is missing! Let's create one for you.");(0,_fileutils.copyFolderContentsRecursiveSync)(_path.default.join(templateFolder,'src'),c.paths.projectSourceFolder);}(0,_common.logTask)('configureProject:check appConfigs');(0,_common.setAppConfig)(c,_path.default.join(c.paths.appConfigsFolder,c.defaultAppConfigId));if(!_fs.default.existsSync(c.paths.appConfigsFolder)){(0,_common.logWarning)("Looks like your appConfig folder "+_chalk.default.white(c.paths.appConfigsFolder)+" is missing! Let's create sample config for you.");(0,_fileutils.copyFolderContentsRecursiveSync)(templateAppConfigsFolder,c.paths.appConfigsFolder);try{var appConfig=JSON.parse(_fs.default.readFileSync(c.paths.appConfigPath).toString());appConfig.common.title=c.files.projectPackage.title;appConfig.common.id=c.defaultProjectConfigs.defaultAppId||c.files.projectPackage.defaultAppId;appConfig.id=c.defaultProjectConfigs.defaultAppConfigId||c.defaultAppConfigId;appConfig.platforms.ios.teamID='';appConfig.platforms.tvos.teamID='';var supPlats=c.defaultProjectConfigs.supportedPlatforms||c.files.projectPackage.supportedPlatforms;if(supPlats){for(var pk in appConfig.platforms){if(!supPlats.includes(pk)){delete appConfig.platforms[pk];}}}_fs.default.writeFileSync(c.paths.appConfigPath,JSON.stringify(appConfig,null,2));}catch(e){(0,_common.logError)(e);}}(0,_common.logTask)('configureProject:check projectConfigs');if(!_fs.default.existsSync(c.paths.projectConfigFolder)){(0,_common.logWarning)("Looks like your projectConfig folder "+_chalk.default.white(c.paths.projectConfigFolder)+" is missing! Let's create one for you.");(0,_fileutils.copyFolderContentsRecursiveSync)(templateProjectConfigFolder,c.paths.projectConfigFolder);}(0,_common.logTask)('configureProject:check plugins');if(_fs.default.existsSync(c.paths.pluginConfigPath)){c.files.pluginConfig=JSON.parse(_fs.default.readFileSync(c.paths.pluginConfigPath).toString());}else{(0,_common.logWarning)("Looks like your plugin config is missing from "+_chalk.default.white(c.paths.pluginConfigPath)+". let's create one for you!");c.files.pluginConfig={plugins:{}};_fs.default.writeFileSync(c.paths.pluginConfigPath,JSON.stringify(c.files.pluginConfig,null,2));}if(!c.files.projectPackage.dependencies){c.files.projectPackage.dependencies={};}var hasPackageChanged=false;for(var k in c.files.pluginConfig.plugins){var dependencies=c.files.projectPackage.dependencies;var devDependecies=c.files.projectPackage.devDependecies;var plugin=(0,_pluginTools.getOriginalPlugin)(c,k,c.files.pluginConfig.plugins);if(dependencies&&dependencies[k]){if(plugin['no-active']!==true&&plugin['no-npm']!==true&&dependencies[k]!==plugin.version){(0,_common.logWarning)("Version mismatch of dependency "+_chalk.default.white(k)+" between:\n"+_chalk.default.white(c.paths.projectPackagePath)+": v("+_chalk.default.red(dependencies[k])+") and\n"+_chalk.default.white(c.paths.pluginConfigPath)+": v("+_chalk.default.red(plugin.version)+").\npackage.json will be overriden");hasPackageChanged=true;dependencies[k]=plugin.version;}}else if(devDependecies&&devDependecies[k]){if(plugin['no-active']!==true&&plugin['no-npm']!==true&&devDependecies[k]!==plugin.version){(0,_common.logWarning)("Version mismatch of devDependency "+_chalk.default.white(k)+" between package.json: v("+_chalk.default.red(devDependecies[k])+") and plugins.json: v("+_chalk.default.red(plugin.version)+"). package.json will be overriden");hasPackageChanged=true;devDependecies[k]=plugin.version;}}else if(plugin['no-active']!==true&&plugin['no-npm']!==true){(0,_common.logWarning)("Missing dependency "+_chalk.default.white(k)+" v("+_chalk.default.red(plugin.version)+") in package.json. package.json will be overriden");hasPackageChanged=true;dependencies[k]=plugin.version;}}if(hasPackageChanged){_fs.default.writeFileSync(c.paths.projectPackagePath,JSON.stringify(c.files.projectPackage,null,2));c._requiresNpmInstall=true;}(0,_common.logTask)('configureProject:check permissions');if(_fs.default.existsSync(c.paths.permissionsConfigPath)){c.files.permissionsConfig=JSON.parse(_fs.default.readFileSync(c.paths.permissionsConfigPath).toString());}else{var newPath=_path.default.join(c.paths.rnvRootFolder,'projectConfig/permissions.json');(0,_common.logWarning)("Looks like your permission config is missing from "+_chalk.default.white(c.paths.permissionsConfigPath)+". ReNative Default "+_chalk.default.white(newPath)+" will be used instead");c.paths.permissionsConfigPath=newPath;c.files.permissionsConfig=JSON.parse(_fs.default.readFileSync(c.paths.permissionsConfigPath).toString());}resolve();});};exports.applyTemplate=applyTemplate;var getTemplateOptions=function getTemplateOptions(){return(0,_common.generateOptions)(DEFAULT_TEMPLATES);};exports.getTemplateOptions=getTemplateOptions;